#ifndef __CHATTAB_H
#define __CHATTAB_H

#include "channel.h"
#include <qtabwidget.h>
#include <qmap.h>

class QAction;

class ChatTab: public QTabWidget
{
    Q_OBJECT
    
	private:
	    typedef QMap<QString, Channel *> ChannelMap;
	    
	    ChannelMap cmap;
	    Channel *prevdel;
	    
	    QString lastactive;
	    
	    bool del(const QString &name);
	    Channel *currentPage()
	    { 
		return static_cast<Channel *>(QTabWidget::currentPage());
	    }
	    
	public slots:
	    void clearCurrent();
	    void on_linkClicked(const QString &link);
	    void scrollDown();
	    
	private slots:
	    void tabChanged(QWidget *widget);
	    void onChannelDoubleClicked(int para, int pos);
	    
	signals:
	    void leave(const QString &channel);
	    void keypressed(const QString & s);
	    void sig_topic_clear(const QString &);
	    void sig_linkClicked(const QString &link);	
	    void saveChatLineText(const QString &chn);
	    void loadChatLineText(const QString &chn);
	    void updateCaption();
	    void actDetected();
	    void channelDoubleClicked(const QString &chn, int para, int pos);
	public:
	    ChatTab(QWidget *parent, const char * name);
	    
	    ~ChatTab();
	    
	    bool isPrivate(const QString &name);
	    bool isPrivate() { return isPrivate(current()); }
	    bool addChannel(const QString &name, QColor back, QFont chatfont);
	    bool delChannel(const QString &name);
	    bool addPrivate(const QString &name, QColor bcolor, QFont chatfont);
	    bool delPrivate(const QString &name);
	    bool clearTopic(const QString &name);
	    bool setTopic(const QString &name, const QString &topic);
	    bool write(const QString &channel, const QString &str, QColor color);
	    bool exists(const QString &name, bool cs = false);
	    bool clearPage(const QString &name);
	    QString getTopic(const QString &name);
	    QString current() { return currentPage()->name(); }
	    QString channelsList();
	    QStringList privatesList();
	    bool saveChatLine(const QString &chn, const QString &text);
	    QString loadChatLine(const QString &chn);
	};

#endif

