/****************************************************************************
                          filesenddlg.ui.h  -  description
                             -------------------
    begin                : Mon Jul 24 22:05:34 EST 2006
    copyright            : (C) 2004-2006 by Sergey Litvinov
    email                : linch@adsl.by
 ****************************************************************************/

/***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  		   *
 *   it under the terms of the GNU General Public License as published by  		   *
 *   the Free Software Foundation; either version 2 of the License, or     		   *
 *  (at your option) any later version.                                   				   *
 ***************************************************************************/

void FileSendDlg::setup(const QString &r)
{
    receiver = r;
    setCaption(tr("Send files to ") + receiver);
    browseButtonPressed();
}

void FileSendDlg::setup(const QString &r, const QString &fn)
{
    receiver = r;
    setCaption(tr("Send files to ") + receiver);

    fnames = QStringList::split(";", fn);
    updateFilesInformation();
}

void FileSendDlg::browseButtonPressed()
{
    fnames = QFileDialog::getOpenFileNames(tr("All files (*)"), QDir::homeDirPath(), this, 0, tr("Select files"));
    updateFilesInformation();
}

void FileSendDlg::updateFilesInformation()
{
    fstr.clear();
    fsize = 0;
    
    for(uint i = 0; i < fnames.count(); i++)
    {
	QFileInfo fi( fnames[i] );
	fsize += fi.size();
	fstr.append('\"' + fi.fileName() + '\"');
    }
    FilesEdit->setText(fstr.join(" "));
    SizeLabel->setText(QString::number((double)fsize/1024, 'f', 2) + tr(" Kb"));
    DescrEdit->setFocus();
}

void FileSendDlg::send()
{
    emit sendFiles(receiver, fnames, DescrEdit->text());
    close();
}
